;===========================================================================================
; Binin2.asm  GoAsm assembler
; Charger un fichier binaire bitmap 16M de couleurs en mmoire et l'afficher  l'cran
; Le fichier binaire bitmap est intgr au fichier .exe
; Programm par AsmGges France
;===========================================================================================
; compile.bat:
; ..\..\bin\GoRC /r, res\binin2.rc
; ..\..\bin\GoAsm binin2.asm
; ..\..\bin\GoLink binin2.obj res\binin2.res user32.dll kernel32.dll gdi32.dll
;===========================================================================================

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  #include "..\..\inc\Windows.inc"
  #include "..\..\inc\all_api.inc"

  ID_FRANCE      = 17

  DIB_RGB_COLORS = 0h
  CBM_INIT       = 04h

;===========================================================================================
; Dbut du code programme
; -----------------------
.code

start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne spcifique
    ; ---------------------------------
    invoke LoadIcon,[wc.hInstance],ID_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur systme
    ; -------------------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Valider la structure WNDCLASS
    ; -----------------------------
    invoke RegisterClass,addr wc

    ; Cration de la fenetre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,0,addr ClassName,addr Titre,WS_CAPTION+WS_POPUP+WS_SYSMENU \
                         +WS_MINIMIZEBOX,[WinX],[WinY],[WinW],[WinH],0,0,[wc.hInstance],0
    mov [hWnd],eax

    ; Affiche et rafraichit la fenetre
    ; --------------------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT
    invoke UpdateWindow,[hWnd]

 ; Boucle des messages
 ; -------------------
 MessageLoop:
    invoke GetMessage,addr msg,0,0,0
    or eax,eax
    jz >ExitProgram
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
    jmp <MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
WindowProc frame @hWnd, @uMsg, @wParam, @lParam
    uses ebx,esi,edi

    cmp D[@uMsg],WM_CLOSE
    jne >.wmcreate
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],addr MsgEnd,addr ClassName,MB_OK+MB_ICONINFORMATION

        ; Supprimer l'objet bitmap
        ; ------------------------
        invoke DeleteObject,[hBitmap]

        ; Supprime le dispositif de contexte
        ; ----------------------------------
        invoke ReleaseDC,[@hWnd],[hdc]

        ; Demande de fin d'application
        ; ----------------------------
        invoke PostQuitMessage,NULL
        jmp >>.exit

    .wmcreate:
    cmp D[@uMsg],WM_CREATE
    jne >.wmpaint
        ; Obtenir le dispositif de contexte
        ; ---------------------------------
        invoke GetDC,[@hWnd]
        mov [hdc],eax

        mov edx,addr hdc
        mov [edx],eax
        mov edx,addr pBitmap
        mov ecx,edx
        add ecx,sizeof BITMAPFILEHEADER             ; dpart de BITMAPINFOHEADER header
        mov eax,[edx+10]
        add edx,eax                                 ; BITMAPFILEHEADER -> bfOffBits

        ; Cre un bitmap dpendant de dispositif de bitmap indpendant de dispositif
        ; --------------------------------------------------------------------------
        invoke CreateDIBitmap,[hdc],ecx,CBM_INIT,edx,ecx,DIB_RGB_COLORS
        mov [hBitmap],eax
        jmp >>.exit

    .wmpaint:
    cmp D[@uMsg],WM_PAINT
    jne >.defwindowproc
        ; Dbut dessin/criture
        ; ---------------------
        invoke BeginPaint,[@hWnd],addr ps

        ; Cre un contexte de dispositif de mmoire compatible avec le hdc indiqu
        ; ------------------------------------------------------------------------
        invoke CreateCompatibleDC,[hdc]
        mov [hMemDC],eax

        ; Slectionne l'objet bitmap
        ; --------------------------
        invoke SelectObject,eax,[hBitmap]

        ; Copie le bitmap
        ; ---------------
        mov eax,addr pBitmap+sizeof BITMAPFILEHEADER  
        invoke BitBlt,[hdc],4,4,[eax+4],[eax+8],[hMemDC],0,0,SRCCOPY

        ; Supprimer le dispositif de contexte
        ; -----------------------------------
        invoke DeleteDC,[hMemDC]

        ; Fin dessin/criture
        ; -------------------
        invoke EndPaint,[@hWnd],addr ps
        jmp >.exit

    .defwindowproc:
        ; Traitement par dfaut des autres messages Windows
        ; ------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .exit:

    mov eax,0
    ret
endf

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
.data

  pBitmap INCBIN res\goasm.bmp
  Titre      db ' Bitmap depuis la mmoire',0
  ClassName  db ' AsmGges Win32',0
  MsgEnd     db ' GoAsm AsmGges France @2006  ',0
  align 4

  WinX       dd 0
  WinY       dd 100
  WinW       dd 300
  WinH       dd 110

  hWnd       dd ?

  hBitmap    dd ?
  hdc        dd ?
  hMemDC     dd ?

  msg        MSG         <>
  wc         WNDCLASS    < 0, addr WindowProc, 0, 0, NULL, NULL, NULL,\
                           COLOR_WINDOW+1, NULL, addr ClassName >
  ps         PAINTSTRUCT <>
  bitmapfileheader BITMAPFILEHEADER <>
  bitmapinfoheader BITMAPINFOHEADER <>

;===========================================================================================
